Download it now!
Bug 125661 - Copying a large sheet is very slow
Summary: Copying a large sheet is very slow
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
6.4.0.0.alpha1+
Hardware: All All
: high major
Assignee: Dennis Francis
URL:
Whiteboard: target:6.4.0 target:6.3.0.1
Keywords: bibisected, bisected, perf, regression
Depends on:
Blocks:
 
Reported: 2019-06-03 16:25 UTC by Telesto
Modified: 2020-03-30 15:43 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Telesto 2019-06-03 16:25:13 UTC
Description:
Copying a large sheet is very slow

Steps to Reproduce:
1. Open attachment 150858 [details]
2. Sheet -> Move or copy sheet
3. Press OK -> Hang/ or very long processing time 

Actual Results:
Hang/ or very long processing time 

Expected Results:
Shouldn't take that long


Reproducible: Always


User Profile Reset: No



Additional Info:
Version: 6.4.0.0.alpha0+ (x86)
Build ID: 93477d1a963e38e3319013e43835a8ffef200972
CPU threads: 4; OS: Windows 6.3; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2019-06-02_10:16:52
Locale: it-IT (nl_NL); UI-Language: en-US
Calc: threaded
Comment 1 Durgapriyanka 2019-06-03 22:16:56 UTC
Thank you for reporting the bug. I can reproduce the bug in

Version: 6.3.0.0.alpha0+
Build ID: b6b28931435e44aca92b8c0e1659f701e3ed1a87
CPU threads: 2; OS: Windows 6.1; UI render: default; VCL: win; 
TinderBox: Win-x86@42, Branch:master, Time: 2019-01-30_06:57:04
Locale: en-US (en_US); UI-Language: en-US
Calc: threaded

but, Cannot reproduce in 
LibreOffice 3.3.0 
OOO330m19 (Build:6)
tag libreoffice-3.3.0.4
Comment 2 Xavier Van Wijmeersch 2019-06-04 08:38:33 UTC
After 5 min closed the document

Version: 6.4.0.0.alpha0+
Build ID: c27e92b29efe573e2cda9844e9ca38965f502443
CPU threads: 8; OS: Linux 4.19; UI render: default; VCL: gtk3; 
Locale: nl-BE (en_US.UTF-8); UI-Language: en-US
Calc: threaded
Comment 3 Telesto 2019-06-04 09:10:49 UTC
@Dennis / Luboš
Any interest in this one, seeing the recent history of performance optimizations in this area
Comment 4 Xisco Faulí 2019-06-04 11:00:17 UTC
this is a recent regression, not reproducible in

Version: 6.2.0.0.alpha1+
Build ID: a20a2d7e0d28658f2d9089da076961a599833a28
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded
Comment 5 Xisco Faulí 2019-06-04 11:32:10 UTC
Regression introduced by:

https://cgit.freedesktop.org/libreoffice/core/commit/?id=e7d0785a7d2a07e64dc58dee4f1b072a72e32aa5

https://cgit.freedesktop.org/libreoffice/core/commit/?id=e7d0785a7d2a07e64dc58dee4f1b072a72e32aa5

author	Dennis Francis <dennis.francis@collabora.com>	2019-03-26 16:50:44 +0530
committer	Eike Rathke <erack@redhat.com>	2019-03-28 22:43:28 +0100
commit	e7d0785a7d2a07e64dc58dee4f1b072a72e32aa5 (patch)
tree	b0e732c070445306f2950b7abdd32a5229df9481
parent	ee92196179d7697a514e55774be09cbf60f2c466 (diff)
tdf#120660: Populate rNewSharedRows even if no FC...

Bisected with: bibisect-linux64-6.3

Adding Cc: to Dennis Francis
Comment 6 Commit Notification 2019-06-24 08:59:14 UTC
Dennis Francis committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/46c8ebe3d352c39bbba1a8099717fbeba384bd1a%5E%21

tdf#125661 : Move the delayed-grouping logic...

It will be available in 6.4.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Xisco Faulí 2019-06-25 16:03:32 UTC
in

Version: 6.4.0.0.alpha0+
Build ID: 52800731baf9fcb88e54d60de5585640c8f97f7b
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

it takes 5 seconds to copy/paste the sheet for me, however, it hangs if I undo the action...
@Dennis, should I report a follow-up bug or you're still working on this one ?
Comment 8 Dennis Francis 2019-06-25 16:15:31 UTC
Yes, it would be good to file a separate bug for the "undo" case. I will close this for now and will backport the fixes together (after they are in master). Thanks !
Comment 9 Xisco Faulí 2019-06-25 16:17:13 UTC
(In reply to Xisco Faulí from comment #7)
> in
> 
> Version: 6.4.0.0.alpha0+
> Build ID: 52800731baf9fcb88e54d60de5585640c8f97f7b
> CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
> Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
> Calc: threaded
> 
> it takes 5 seconds to copy/paste the sheet for me, however, it hangs if I
> undo the action...
> @Dennis, should I report a follow-up bug or you're still working on this one
> ?

Yes, this is also reproduced in

Version: 6.1.0.0.alpha1+
Build ID: 3a801799536e6870f2fb111b1cc00b9575a35a39
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); Calc: group

so it's not related to your commit... Setting this to VERIFIED
Comment 10 Commit Notification 2019-06-26 12:21:44 UTC
Dennis Francis committed a patch related to this issue.
It has been pushed to "libreoffice-6-3":

https://git.libreoffice.org/core/+/e4553dbf3d4c47c10326c9d2f0bedfe69922d3d4%5E%21

tdf#125661 : Move the delayed-grouping logic...

It will be available in 6.3.0.1.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 11 Xisco Faulí 2019-06-27 08:29:36 UTC
The commits depends on 169a1b542165f3444791fd6e672d56d3fe48bd66, which is not backported to 6-2 branch, thus, we can't backport it...
Comment 12 b. 2020-03-30 10:36:29 UTC
reopening: 

0.) still performance issue in special situation, see point F.) below

A.) with ver 6.2.8.2 it took more than 4:30 - hours! - to do 'sheet - move or copy sheet', not finished after that time, killed the task, 

with ver. below (7.0 about 1 week old) it takes: 

B.) 11,5 seconds to open the file provided by the OP, acceptable, 

C.) +/- 2,83 sec. to copy the existing sheet to another by '+' to add sheet and then ctrl-a - ctrl-c on the old, ctrl-v on the new sheet, good, 

D.) +/- 2,05 sec. for undo after that with ctrl-z, good, 

E.) similar times for copy and undo with 'move or copy sheet' done after! C.) and D.), 

but! 

F.) more than 4:25 minutes (265 seconds!) to finish if you execute 'sheet - move or copy sheet' as the first action after loading the file (and starting the program?), 

thus there is still an unneccessary performance issue, unneccessary as F.) isn't 'more work' than C.) 

ver. tested: 

Version: 7.0.0.0.alpha0+ (x64)
Build ID: 61d8d991a27c3bfe70e3b8d3b4ce4d8a41d18d2d
CPU threads: 8; OS: Windows 6.1 Service Pack 1 Build 7601; UI render: default; VCL: win; 
Locale: de-DE (de_DE); UI-Language: en-US
Calc:
Comment 13 Xisco Faulí 2020-03-30 10:54:28 UTC
(In reply to b. from comment #12)
> reopening: 

Please, create a new report. Closing as VERIFIED FIXED